﻿using System.Collections.Generic;
using System.Web.UI.WebControls;
using TheBeerHouse.Store;
using TheBeerHouse.UI;

partial class Admin_ManageProducts : AdminPage
{
    
    protected void Page_Load(object sender, System.EventArgs e)
    {
        
        if (!IsPostBack) {
            BindDepartmentsToListControl(ddlDepartments, true);
            BindProducts();
            
        }
    }
    
    protected void BindProducts()
    {
        using (ProductsRepository lProductsrpt = new ProductsRepository()) {
            
            List<Product> lProducts;
            
            if (DepartmentId > 0) {
                lProducts = lProductsrpt.GetProductsByDepartment(DepartmentId);
            }
            else {
                lProducts = lProductsrpt.GetProducts();
            }
            
            lvProducts.DataSource = lProducts;
            lvProducts.DataBind();
            
            DataPager pagerBottom = (DataPager)lvProducts.FindControl("pagerBottom");
            
            pagerBottom.PageSize = int.Parse(ddlProductsPerPage.SelectedValue);
            
            if ((pagerBottom != null)) {
                if (lProducts.Count <= pagerBottom.PageSize) {
                    pagerBottom.Visible = false;
                }
                else {
                    pagerBottom.Visible = true;
                }
            }
        }
    }
    
    protected void lvProducts_PagePropertiesChanged(object sender, System.EventArgs e)
    {
        BindProducts();
    }
    
    protected void ddlProductsPerPage_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        BindProducts();
    }
    
    protected void ddlDepartments_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        DepartmentId = int.Parse(ddlDepartments.SelectedValue);
        BindProducts();
    }
    
}